      subroutine predmixdamsn(x,n,p,G,pro,mu,sigma,delta,
     &tau,error)
      implicit NONE
      integer            n, p, G, error
      double precision   x(n,*), tau(n,  *  ),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      double precision        zero, loglik
      parameter              (zero = 0.d0)
      error  = 0
      call denmsn(x,n,p,g,mu,sigma,delta,tau,error)
      if(error .ne. 0) then
      error=22
      return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,error)
      if(error .ne. 0) then
      error=23
      return
      endif
      return
      end
      subroutine getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
      implicit NONE
      integer            p,k,g
      double precision wx(p),wy(p),wd(p),inv(p,p),denmax
      double precision tempyy, tempdd, tempyd, temp
      double precision modpts(p,g),mu(p,g),y(p)
      double precision        zero, one, two
      parameter   (zero = 0.d0, one = 1.d0, two = 2.d0)
      external                ddot, mvphin
      double precision        ddot, mvphin
      call dcopy( p, y, 1, wx, 1)
      call daxpy( p, (-one), mu(1,k), 1, wx, 1)
      call dgemv("N", p, p, one, inv, p, wx, 1, zero, wy, 1);
      tempyy = ddot( p, wy, 1, wy, 1)
      tempyd = ddot( p, wd, 1, wy, 1)
      temp =- tempyy/two
     &+log(two*mvphin(tempyd/sqrt(one-tempdd)))
      if(temp .gt. denmax) then
      call dcopy( p, y, 1, modpts(1,k), 1)
      denmax = temp
      endif
      return
      end
      subroutine getmodmsn2(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
      implicit NONE
      integer            p,k,g
      double precision wx(p),wy(p),wd(p),inv(p,p),denmax
      double precision tempyy, tempdd, tempyd, temp
      double precision modpts(p,g),mu(p,g),y(p)
      double precision        zero, one, two
      parameter   (zero = 0.d0, one = 1.d0, two = 2.d0)
      external                ddot, mvphin
      double precision        ddot, mvphin
      call dcopy( p, y, 1, wx, 1)
      call daxpy( p, (-one), mu(1,k), 1, wx, 1)
      call dgemv("N", p, p, one, inv, p, wx, 1, zero, wy, 1);
      tempyy = ddot( p, wy, 1, wy, 1)
      tempyd = ddot( p, wd, 1, wy, 1)
      temp =- tempyy/two
     &+log(two*mvphin(tempyd/sqrt(one-tempdd)))
            call dcopy( p, y, 1, modpts(1,k), 1)
            denmax = temp
      return
      end
      subroutine mixmodmsn(p,G,step,mu,Sigma,delta,
     +emean,esigma,modpts,error)
      implicit NONE
      integer            p, G, error
      double precision   delta(p,*),step
      double precision   mu(p,*), Sigma(p,p,*)
      double precision   emean(p,*), esigma(p,p,*),modpts(p,*)
      double precision   sigmad(p,p), wd(p), y(p)
      integer                 i, j, k, n
      double precision        inv(p,p),logdet,wx(p)
      double precision        tempdd
      double precision        const, tsd, denmax
      integer                 i1, i2, i3, i4, i5
      integer                 i6, i7, i8, i9, i10
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      double precision        pi
      parameter              (pi =    3.141592653589793239d0)
      external                ddot, mvphin
      double precision        ddot, mvphin
      integer counter,save(p),ii
      error  = 0
      if( (p .gt. 10)  ) return
      do k = 1, G
         const = two/pi
         do i=1,p
         emean(i,k)=mu(i,k)+sqrt(const)*delta(i,k)
       do j=i,p
            sigmad(i,j)=sigma(i,j,k)+delta(i,k)*delta(j,k)
            esigma(i,j,k)=sigma(i,j,k)+(1-const)*delta(i,k)*delta(j,k)
            esigma(j,i,k)=esigma(i,j,k)
       enddo
       enddo
         tsd = zero
         do j =1, p
           if(esigma(j,j,k) .gt. tsd) then
            tsd=esigma(j,j,k)
           endif
         enddo
         tsd = sqrt(tsd)
         n = max(20,int(two*tsd/step))
        do i=1,p
          do j=i,p
            sigmad(i,j)=sigma(i,j,k)
          enddo
        enddo
        call inverse3(sigmad,inv,logdet,p,error,counter,save)
        if(error .ne. 0) then
                error = 11
                return
        endif
        if(counter .ge. 1) then
           do j=1,counter
              i=save(j)
              delta(i,k)=zero
              do ii=1,p
                sigmad(ii,i)=zero
                sigmad(i,ii)=zero
              enddo
              sigmad(i,i)=1e-4
           enddo
        endif
        do i=1,p
          do j=i,p
            sigmad(i,j)=sigmad(i,j)+delta(i,k)*delta(j,k)
          enddo
        enddo
        call inverse3(sigmad,inv,logdet,p,error,counter,save)
        if(error .ne. 0) then
        error=22
                return
        endif
        call dcopy( p, delta(1,k), 1, wx, 1)
        call dgemv("N", p, p, one, inv, p, wx, 1, zero, wd, 1);
        tempdd = ddot( p, wd, 1, wd, 1)
        do i=1,p
          call dcopy( p, mu(1,k), 1, y, 1)
        enddo
        call getmodmsn2(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
        do i1 = 1,n
           y(1)=emean(1,k)-tsd+(i1-1)*step
          if(p .eq. 1) then
           call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          endif
          if(p .eq.2) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
       call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          endif
          if(p.eq.3) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          endif
          if(p.eq.4) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          endif
          if(p.eq.5) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.6) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.7) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.8) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          do i8=1,n
           y(8)=emean(8,k)-tsd+(i8-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.9) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          do i8=1,n
           y(8)=emean(8,k)-tsd+(i8-1)*step
          do i9=1,n
           y(9)=emean(9,k)-tsd+(i9-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.10) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          do i8=1,n
           y(8)=emean(8,k)-tsd+(i8-1)*step
          do i9=1,n
           y(9)=emean(9,k)-tsd+(i9-1)*step
          do i10=1,n
           y(10)=emean(10,k)-tsd+(i10-1)*step
      call getmodmsn(p,g,k,y,mu,inv,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
       enddo
      enddo
      return
      end
